include:
  remote: https://gitlab.com/pantacor/ci/ci-templates/raw/4ab47ca6cd388c3db74444868d42ace5b73bc8b0/build-dockerfile.yml


build-amd64:
  extends: .build-dockerfile
  variables:
    ARCH: amd64
    QEMU_ARCH: x86_64

build-arm32v6:
  extends: .build-dockerfile
  variables:
    ARCH: arm32v6
    QEMU_ARCH: arm

build-arm64v8:
  extends: .build-dockerfile
  variables:
    ARCH: arm64v8
    QEMU_ARCH: aarch64

build-mips64:
  stage: build
  variables:
    ARCH: mips64
    QEMU_ARCH: mips64
  before_script:
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN registry.gitlab.com
    - docker run --rm --privileged multiarch/qemu-user-static:register || true
    - apk update; apk add gettext
    - DOCKERFILE_NAME="Dockerfile.$ARCH"
    - DOCKER_CONTAINER_NAME=$ARCH
  script:
    - DOCKER_CONTAINER_COMMIT_NAME=$DOCKER_CONTAINER_NAME-$CI_COMMIT_SHA
    - DOCKER_CONTAINER_BRANCH_NAME=$DOCKER_CONTAINER_NAME-$CI_COMMIT_REF_SLUG
    - DOCKER_CONTAINER_BRANCH_NAME_NORM=${DOCKER_CONTAINER_BRANCH_NAME%%-master}
    - DOCKER_CONTAINER_TAG_NAME=$DOCKER_CONTAINER_NAME-$CI_BUILD_TAG
    - cp $DOCKERFILE_NAME Dockerfile
    - docker pull $CONTAINER_IMAGE:$DOCKER_CONTAINER_BRANCH_NAME_NORM || true
    - docker build --cache-from $CONTAINER_IMAGE:$DOCKER_CONTAINER_BRANCH_NAME_NORM --tag $CONTAINER_IMAGE:$DOCKER_CONTAINER_COMMIT_NAME --tag $CONTAINER_IMAGE:$DOCKER_CONTAINER_BRANCH_NAME_NORM .
    - test -n "$CI_BUILD_TAG" && docker tag $CONTAINER_IMAGE:$DOCKER_CONTAINER_COMMIT_NAME $CONTAINER_IMAGE:$DOCKER_CONTAINER_TAG_NAME || true
    - docker push $CONTAINER_IMAGE:$DOCKER_CONTAINER_COMMIT_NAME
    - docker push $CONTAINER_IMAGE:$DOCKER_CONTAINER_BRANCH_NAME_NORM
    - test -n "$CI_BUILD_TAG" && docker push $CONTAINER_IMAGE:$DOCKER_CONTAINER_TAG_NAME || true
